<?php

require_once("Action/Common.php");

interface Action_Interface
{
	// Upload file into local/remote host
	public function upload($srcfile, $dstfile, $mode);

	// Download file from local/remote host
	public function download($srcfile, $dstfile, $mode);

	// Execute remote/local script
	public function exec($cmd);
}

class Action
{
	public static function factory()
	{
		$opts = getCmdOptions();
		$path_opts = $opts->get_path_opts();
		if (!$path_opts['host']) {
			$type = "Filesys";
		} else {
			$type = "Connect";
		}

		$class_name = "Action_" . $type;
		require_once("Action/$type.php");
		$obj = new $class_name();
		return $obj;
	}
}
